#!/usr/bin/python

def directory (a, b, c = None):
	import string
	print string.replace (b ["EXTRA_DIST"], '\n', '\\\n')
	return (a, b, c)



directory ('.', 
	{	"SUBDIRS" : "man doc Win32 MacOS Octave src examples tests",
		"DIST_SUBDIRS" : "$(SUBDIRS)",
		"EXTRA_DIST" : 
				"reconf acinclude.m4 libsndfile.spec.in sndfile.pc.in" \
				"	check_libsndfile.py libsndfile_version_convert.py Make.bat",
		"pkgconfigdir" : "$(libdir)/pkgconfig",
		"pkgconfig_DATA" : "sndfile.pc",
		"m4datadir" : "$(datadir)/aclocal"
		}
)

directory ('src', 
	{	"SUBDIRS" :"GSM610 G72x",

		"lib_LTLIBRARIES" : "libsndfile.la",
		"include_HEADERS" : "sndfile.h",
		"EXTRA_DIST" : "sndfile.h.in config.h.in Version_script.in",

		"noinst_HEADERS" : "common.h sfendian.h float_cast.h wav_w64.h au.h",

		"COMMON" :
			"sndfile.c common.c file_io.c command.c pcm.c ulaw.c alaw.c float32.c" \
			"	double64.c ima_adpcm.c ms_adpcm.c gsm610.c dwvw.c sfendian.c vox_adpcm.c" \
			"	interleave.c strings.c dither.c",

		"FILESPECIFIC" : 
			"aiff.c au.c au_g72x.c ircam.c mat4.c mat5.c nist.c paf.c" \
			"	pvf.c raw.c svx.c voc.c w64.c wav.c wav_w64.c htk.c" \
			"	sd2.c rx2.c txw.c sds.c wve.c dwd.c ogg.c xi.c",
				
		"libsndfile_la_SOURCES" : "$(COMMON) $(FILESPECIFIC) $(noinst_HEADERS) sndfile.h",
		"libsndfile_la_LDFLAGS" : "-version-info @SHARED_VERSION_INFO@ @SHLIB_VERSION_ARG@",
		"libsndfile_la_LIBADD" : "GSM610/libgsm.la G72x/libg72x.la -lm",

		
		"AUTOHEADER" : "echo"
		},
	{	"aiff.c au.c au_g72x.c ircam.c mat4.c mat5.c nist.c paf.c pvf.c" : "sndfile.h common.h",
		"raw.c svx.cvoc.c w64.c wav.c wav_w64.c htk.c sd2.c rx2.c txw.c" : "sndfile.h common.h",
		"sds.c wve.c dwd.c ogg.c xi.c sndfile.c common.c file_io.c" : "sndfile.h common.h",
		"command.c pcm.c ulaw.c alaw.c float32.c double64.c ima_adpcm.c" : "sndfile.h common.h",
		"ms_adpcm.c gsm610.c dwvw.c sfendian.c vox_adpcm.c interleave.c" : "sndfile.h common.h",
		" strings.c dither.c" : "sndfile.h common.h"
		}
	)

directory ('Octave', 
	{	"EXTRA_DIST" : "sndfile_load.m sndfile_save.m sndfile_play.m",
		"octconfigdir" : "$(exec_prefix)/share/octave/site/m",
		"octconfig_DATA" : "sndfile_load.m sndfile_save.m sndfile_play.m"
		}
	)

directory ('tests', 
	{	"noinst_PROGRAMS" :
			"sfversion floating_point_test write_read_test "\
			"		lossy_comp_test error_test ulaw_test alaw_test dwvw_test" \
			"		peak_chunk_test command_test stdin_test stdout_test stdio_test" \
			"		pcm_test headerless_test pipe_test benchmark misc_test raw_test" \
			"		string_test dither_test fix_this",

		"SNDFILEDIR" : "src",
		"INCLUDES" : "-I$(srcdir)/$(SNDFILEDIR)",
		"noinst_HEADERS" : "dft_cmp.h utils.h",

		"autogen_sources" :
			"write_read_test.tpl write_read_test.def" \
			"		pcm_test.tpl pcm_test.def" \
			"		utils.tpl utils.def" \
			"		command_test.tpl command_test.def" \
			"		benchmark.tpl benchmark.def",

		"EXTRA_DIST" : "$(autogen_sources)",

		"sfversion_SOURCES" : "sfversion.c",
		"sfversion_LDADD" : "$(SNDFILEDIR)/libsndfile.la",

		"write_read_test_SOURCES" : "utils.c write_read_test.c",
		"write_read_test_LDADD" : "$(SNDFILEDIR)/libsndfile.la",

		"lossy_comp_test_SOURCES" : "utils.c lossy_comp_test.c",
		"lossy_comp_test_LDADD" : "$(SNDFILEDIR)/libsndfile.la",

		"fix_this_SOURCES" : "utils.c fix_this.c",
		"fix_this_LDADD" : "$(SNDFILEDIR)/libsndfile.la",

		"error_test_SOURCES" : "error_test.c",
		"error_test_LDADD" : "$(SNDFILEDIR)/libsndfile.la",

		"ulaw_test_SOURCES" : "utils.c ulaw_test.c",
		"ulaw_test_LDADD" : "$(SNDFILEDIR)/libsndfile.la",

		"alaw_test_SOURCES" : "utils.c alaw_test.c",
		"alaw_test_LDADD" : "$(SNDFILEDIR)/libsndfile.la",

		"dwvw_test_SOURCES" : "utils.c dwvw_test.c",
		"dwvw_test_LDADD" : "$(SNDFILEDIR)/libsndfile.la",

		"floating_point_test_SOURCES" : "utils.c dft_cmp.c floating_point_test.c",
		"floating_point_test_LDADD" : "$(SNDFILEDIR)/libsndfile.la",

		"peak_chunk_test_SOURCES" : "peak_chunk_test.c utils.c",
		"peak_chunk_test_LDADD" : "$(SNDFILEDIR)/libsndfile.la",

		"command_test_SOURCES" : "command_test.c utils.c",
		"command_test_LDADD" : "$(SNDFILEDIR)/libsndfile.la",

		"pcm_test_SOURCES" : "pcm_test.c utils.c",
		"pcm_test_LDADD" : "$(SNDFILEDIR)/libsndfile.la",

		"headerless_test_SOURCES" : "utils.c headerless_test.c",
		"headerless_test_LDADD" : "$(SNDFILEDIR)/libsndfile.la",

		"stdin_test_SOURCES" : "stdin_test.c utils.c",
		"stdin_test_LDADD" : "$(SNDFILEDIR)/libsndfile.la",

		"stdout_test_SOURCES" : "stdout_test.c",
		"stdout_test_LDADD" : "$(SNDFILEDIR)/libsndfile.la",

		"stdio_test_SOURCES" : "stdio_test.c",
		"stdio_test_LDADD" : "",

		"pipe_test_SOURCES" : "pipe_test.c",
		"pipe_test_LDADD" : "",

		"benchmark_SOURCES" : "benchmark.c",
		"benchmark_LDADD" : "$(SNDFILEDIR)/libsndfile.la",

		"misc_test_SOURCES" : "misc_test.c utils.c",
		"misc_test_LDADD" : "$(SNDFILEDIR)/libsndfile.la",
		"raw_test_SOURCES" : "raw_test.c utils.c",
		"raw_test_LDADD" : "$(SNDFILEDIR)/libsndfile.la",

		"string_test_SOURCES" : "string_test.c utils.c",
		"string_test_LDADD" : "$(SNDFILEDIR)/libsndfile.la",

		"dither_test_SOURCES" : "dither_test.c utils.c",
		"dither_test_LDADD" : "$(SNDFILEDIR)/libsndfile.la",
		},

"""

#===============================================================================

write_read_test.c: write_read_test.def write_read_test.tpl
	autogen --writable --source-time write_read_test.def

pcm_test.c: pcm_test.def pcm_test.tpl
	autogen --writable --source-time pcm_test.def

utils.c: utils.def utils.tpl
	autogen --writable --source-time utils.def

command_test.c: command_test.def command_test.tpl
	autogen --writable --source-time command_test.def

benchmark.c: benchmark.def benchmark.tpl
	autogen --writable --source-time benchmark.def

#===============================================================================

check: generic-tests ulaw_test alaw_test floating_point_test \
		wav-tests aiff-tests au-tests raw-tests paf-tests svx-tests nist-tests \
		ircam-tests voc-tests w64-tests mat4-tests mat5-tests pvf-tests \
		xi-tests htk-tests stdio-tests

generic-tests : error_test ulaw_test alaw_test command_test floating_point_test pcm_test
	uname -a
	./error_test
	./pcm_test
	./ulaw_test
	./alaw_test
	./dwvw_test
	./command_test ver
	./command_test norm
	./command_test format
	./command_test peak
	./command_test trunc
	./floating_point_test
	./headerless_test
	@echo "----------------------------------------------------------------------"
	@echo "  `./sfversion` passed common tests."
	@echo "----------------------------------------------------------------------"

wav-tests: write_read_test lossy_comp_test peak_chunk_test misc_test
	./write_read_test wav
	./lossy_comp_test wav_ima
	./lossy_comp_test wav_msadpcm
	./lossy_comp_test wav_ulaw
	./lossy_comp_test wav_alaw
	./lossy_comp_test wav_gsm610
	./peak_chunk_test wav
	./misc_test wav
	./string_test wav
	@echo "----------------------------------------------------------------------"
	@echo "  `./sfversion` passed tests on WAV files."
	@echo "----------------------------------------------------------------------"

aiff-tests: write_read_test lossy_comp_test peak_chunk_test misc_test
	./write_read_test aiff
	./lossy_comp_test aiff_ulaw
	./lossy_comp_test aiff_alaw
	./lossy_comp_test aiff_gsm610
	./peak_chunk_test aiff
	./misc_test aiff
	@echo "----------------------------------------------------------------------"
	@echo "  `./sfversion` passed tests on AIFF files."
	@echo "----------------------------------------------------------------------"

au-tests: write_read_test lossy_comp_test misc_test
	./write_read_test au
	./lossy_comp_test au_ulaw
	./lossy_comp_test au_alaw
	./lossy_comp_test au_g721
	./lossy_comp_test au_g723
	./misc_test au
	@echo "----------------------------------------------------------------------"
	@echo "  `./sfversion` passed tests on AU files."
	@echo "----------------------------------------------------------------------"

raw-tests: write_read_test lossy_comp_test raw_test
	./write_read_test raw
	./lossy_comp_test raw_ulaw
	./lossy_comp_test raw_alaw
	./lossy_comp_test vox_adpcm
	./raw_test
	@echo "----------------------------------------------------------------------"
	@echo "  `./sfversion` passed tests on RAW (header-less) files."
	@echo "----------------------------------------------------------------------"

paf-tests: write_read_test misc_test
	./write_read_test paf
	./misc_test paf
	@echo "----------------------------------------------------------------------"
	@echo "  `./sfversion` passed tests on PAF files."
	@echo "----------------------------------------------------------------------"

svx-tests: write_read_test misc_test
	./write_read_test svx
	./misc_test svx
	@echo "----------------------------------------------------------------------"
	@echo "  `./sfversion` passed tests on SVX files."
	@echo "----------------------------------------------------------------------"

nist-tests: write_read_test lossy_comp_test misc_test
	./write_read_test nist
	./lossy_comp_test nist_ulaw
	./lossy_comp_test nist_alaw
	./misc_test nist
	@echo "----------------------------------------------------------------------"
	@echo "  `./sfversion` passed tests on NIST files."
	@echo "----------------------------------------------------------------------"

ircam-tests: write_read_test lossy_comp_test misc_test
	./write_read_test ircam
	./lossy_comp_test ircam_ulaw
	./lossy_comp_test ircam_alaw
	./misc_test ircam
	@echo "----------------------------------------------------------------------"
	@echo "  `./sfversion` passed tests on IRCAM files."
	@echo "----------------------------------------------------------------------"

voc-tests: write_read_test lossy_comp_test misc_test
	./write_read_test voc
	./lossy_comp_test voc_ulaw
	./lossy_comp_test voc_alaw
	./misc_test voc
	@echo "----------------------------------------------------------------------"
	@echo "  `./sfversion` passed tests on VOC files."
	@echo "----------------------------------------------------------------------"

w64-tests: write_read_test lossy_comp_test misc_test
	./write_read_test w64
	./lossy_comp_test w64_ima
	./lossy_comp_test w64_msadpcm
	./lossy_comp_test w64_ulaw
	./lossy_comp_test w64_alaw
	./lossy_comp_test w64_gsm610
	./misc_test w64
	@echo "----------------------------------------------------------------------"
	@echo "  `./sfversion` passed tests on W64 files."
	@echo "----------------------------------------------------------------------"

mat4-tests: write_read_test misc_test
	./write_read_test mat4
	./misc_test mat4
	@echo "----------------------------------------------------------------------"
	@echo "  `./sfversion` passed tests on MAT4 files."
	@echo "----------------------------------------------------------------------"

mat5-tests: write_read_test misc_test
	./write_read_test mat5
	./misc_test mat5
	@echo "----------------------------------------------------------------------"
	@echo "  `./sfversion` passed tests on MAT5 files."
	@echo "----------------------------------------------------------------------"

pvf-tests: write_read_test misc_test
	./write_read_test pvf
	./misc_test pvf
	@echo "----------------------------------------------------------------------"
	@echo "  `./sfversion` passed tests on PVF files."
	@echo "----------------------------------------------------------------------"

xi-tests: lossy_comp_test
	./lossy_comp_test xi_dpcm
	@echo "----------------------------------------------------------------------"
	@echo "  `./sfversion` passed tests on XI files."
	@echo "----------------------------------------------------------------------"

htk-tests: write_read_test misc_test
	./write_read_test htk
	./misc_test htk
	@echo "----------------------------------------------------------------------"
	@echo "  `./sfversion` passed tests on HTK files."
	@echo "----------------------------------------------------------------------"

stdio-tests: stdio_test stdin_test stdout_test pipe_test
	./stdio_test
	./pipe_test
	@echo "----------------------------------------------------------------------"
	@echo "  `./sfversion` passed stdio and pipe tests."
	@echo "----------------------------------------------------------------------"


""")

directory ('src/GSM610', 
	{	"EXTRA_DIST" : "README COPYRIGHT ChangeLog",

		"noinst_HEADERS" : "gsm.h config.h gsm610_priv.h",
		"noinst_LTLIBRARIES" : "libgsm.la",

		"CFILES" : 
			"add.c decode.c gsm_decode.c gsm_encode.c long_term.c preprocess.c" \
			"	short_term.c code.c gsm_create.c gsm_destroy.c gsm_option.c lpc.c" \
			"	rpe.c table.c",

		"libgsm_la_SOURCES" : "$(CFILES) $(noinst_HEADERS)",

		"AUTOHEADER" : "echo"
		}
	)

directory ('src/G72x', 

	{	"EXTRA_DIST" : "README README.original ChangeLog",

		"noinst_HEADERS" : "g72x.h g72x_priv.h",
		"noinst_LTLIBRARIES" : "libg72x.la",

		"noinst_PROGRAMS" : "g72x_test",

		"CFILES" : "g72x.c g721.c g723_16.c g723_24.c g723_40.c",

		"libg72x_la_SOURCES" : "$(CFILES) $(noinst_HEADERS)",

		"g72x_test_SOURCES" : "g72x_test.c",
		"g72x_test_LDADD" : "./libg72x.la -lm",

		"AUTOHEADER" : "echo"
		},

"""check: g72x_test
	./g72x_test all


""")

directory ('man',
	{	"man_MANS" : "sndfile-info.1 sndfile-play.1 sndfile-convert.1",
		"EXTRA_DIST" : " sndfile-info.1 sndfile-play.1 sndfile-convert.1"
		}
	)

directory ('examples', 
	{	"bin_PROGRAMS" : "sndfile-info sndfile-play sndfile-convert",

		"noinst_PROGRAMS" : "make_sine sfprocess list_formats cooledit-fixer generate",

		# This is the BeOS version of sndfile-play. It needs to be compiled 
		# with the C++ compiler.
		"EXTRA_DIST" : "sndfile-play-beos.cpp",


		"OS_SPECIFIC_INCLUDES" : "@OS_SPECIFIC_INCLUDES@",
		"OS_SPECIFIC_LINKS" : "@OS_SPECIFIC_LINKS@",

		"SNDFILEDIR" : "src",
		"INCLUDES" : "-I$(srcdir)/$(SNDFILEDIR) $(OS_SPECIFIC_INCLUDES)",

		"sndfile_info_SOURCES" : "sndfile-info.c",
		"sndfile_info_LDADD" : "$(SNDFILEDIR)/libsndfile.la",

		"sndfile_play_SOURCES" : "sndfile-play.c",
		"sndfile_play_LDADD" : "$(SNDFILEDIR)/libsndfile.la $(OS_SPECIFIC_LINKS)",

		"sndfile_convert_SOURCES" : "sndfile-convert.c",
		"sndfile_convert_LDADD" : "$(SNDFILEDIR)/libsndfile.la",
 
		"make_sine_SOURCES" : "make_sine.c",
		"make_sine_LDADD" : "$(SNDFILEDIR)/libsndfile.la",

		"sfprocess_SOURCES" : "sfprocess.c",
		"sfprocess_LDADD" : "$(SNDFILEDIR)/libsndfile.la",

		"list_formats_SOURCES" : "list_formats.c",
		"list_formats_LDADD" : "$(SNDFILEDIR)/libsndfile.la",

		"cooledit_fixer_SOURCES" : "cooledit-fixer.c",
		"cooledit_fixer_LDADD" : "$(SNDFILEDIR)/libsndfile.la",

		"generate_SOURCES" : "generate.c",
		"generate_LDADD" : "$(SNDFILEDIR)/libsndfile.la",
		}
	)

directory ('doc',
	{	"EXTRA_DIST" :
			"index.html libsndfile.jpg libsndfile.css api.html command.html" \
			"	bugs.html sndfile_info.html new_file_type.HOWTO pkgconfig.html" \
			"	win32.html FAQ.html lists.html octave.html dither.html"
		}
	)

directory ('Win32', 
	{	"EXTRA_DIST" : "README-Win32.txt sndfile.h config.h unistd.h libsndfile.def Makefile.msvc"
		}
	)

directory ('MacOS',
	{	"EXTRA_DIST" : "config.h sndfile.h MacOS-readme.txt",
		"DISTCLEANFILES" : "Makefile"
		}
	)


# Do not edit or modify anything in this comment block.
# The arch-tag line is a file identity tag for the GNU Arch 
# revision control system.
#
# arch-tag: ada9c381-09a7-410c-9b82-98cc89219aff

