#!/usr/bin/python

import os, re, string, sys, time

BUILD_RPM = 0
BUILD_ZIP = 0

# AC_INIT(libsndfile,1.1.0pre1,<erikd@mega-nerd.com>)
def find_configure_version (filename):
	file = open (filename)
	while 1:
		line = file.readline ()
		if re.search ("AC_INIT\(", line):
			line = re.sub ("AC_INIT\(", "", line)
			x = re.sub ("\).*\n", "", line)
			package, version, rubbish = string.split (x, ",", 3)
			break
	file.close ()
	# version = re.escape (version)
	return package, version
	
def find_header_version (filename):
	file = open (filename)
	while 1:
		line = file.readline ()
		if not line:
			print "Error : could not find version in :", filename
			sys.exit (1)
		if re.search ("#define[ \t]+VERSION", line):
			version = re.sub ("[#a-zA-Z \t]+\"", "", line)
			version = re.sub ("\".*\n", "", version)
			break
	file.close ()
	# version = re.escape (version)
	return version
	
def html_find_configure_version (data):
	if os.path.isfile (data):
		file = open (data, "r")
		data = file.read ()
		file.close ()
	version = re.search ("<META NAME=\"Version\"[ \t]+CONTENT=\"libsndfile-[^\"]+\">", data)
	version = re.search ("libsndfile-[^\"]+\"", version.group (0))
	version = re.sub ("(libsndfile-|\")", "", version.group (0))
	return version

def html_fix_version (filename, new_version):
	file = open (filename, "r")
	data = file.read ()
	file.close () 
	temp_filename = "%s.%d" % (filename, int (time.time ()))
	os.rename (filename, temp_filename)
	html_version = html_find_configure_version (data)
	
	try:
		if html_version != new_version:
			print "Updating html file version number."
	
			data = re.sub (re.escape ("-%s" % html_version), "-%s" % new_version, data)

			html_zip_version = "-" + re.sub ("\.", "_", html_version)
			new_zip_version  = "-" + re.sub ("\.", "_", new_version)
		
			data = re.sub (html_zip_version, new_zip_version, data)
	
			file = open (filename, "w")
			file.write (data)
			file.close ()
			os.unlink (temp_filename)
		else:
			os.rename (temp_filename, filename)
			
	except:
		print "Html file update failed."
		os.rename (temp_filename, filename)
		sys.exit (1)

#print html_find_configure_version ("doc/index.html")
#
#sys.exit (0)


#=========================================================================
# Main program.

conf_package, conf_version = find_configure_version ("configure.ac")

header_version = find_header_version ("src/config.h")

win32_version = find_header_version ("Win32/config.h")

if conf_version != header_version:
	print "Configure/header version mismatch!", conf_version, header_version
	sys.exit (0)
	
if conf_version != win32_version:
	os.system ("mgdiff Win32/config.h src/config.h")

os.system ("mgdiff Win32/sndfile.h src/sndfile.h")

os.system ("nedit AUTHORS NEWS README ChangeLog")

os.system ("nedit doc/*.html")

# Generate the filenames from the versions.
	
tar_gz_file = "%s-%s.tar.gz" % (conf_package, conf_version)
zip_file = "%s-%s.zip" % (conf_package, re.escape (re.sub ("\.", "_", conf_version)))
rpm_file = "%s-%s-1.i386.rpm" % (conf_package, conf_version)
rpm_dev_file = "%s-devel-%s-1.i386.rpm" % (conf_package, conf_version)
rpm_src_file = "%s-%s-1.src.rpm" % (conf_package, conf_version)

if not os.path.isfile (tar_gz_file):
	print "Tar.gz file does not exist. Creating it."
	os.system ("make dist")
	os.system ("chmod a+r %s" % tar_gz_file)

if BUILD_ZIP and not os.path.isfile (zip_file):
	print "Zip file does not exist. Creating it."
	os.system ("rm -f %s" % zip_file)
	os.system ("tar zxf %s" % tar_gz_file)
	os.system ("zip -rg %s %s-%s" % (zip_file, conf_package, conf_version))
	os.system ("rm -rf %s-%s" % (conf_package, conf_version))
	os.system ("chmod a+r %s" % zip_file)

if BUILD_RPM and not os.path.isfile (rpm_file):
	print "RPM files do not exist. Creating them."

	command = "cp %s /usr/src/redhat/SOURCES/ ; " % tar_gz_file + "rpm -ba libsndfile.spec"
	
	print "Will need to become root to run the following command."
	print command
	print "\n    *********************************************\n"
	os.system ("su -c \"%s\"" % command)
	
	os.system ("cp /usr/src/redhat/RPMS/i386/%s ." % rpm_file)
	os.system ("cp /usr/src/redhat/RPMS/i386/%s ." % rpm_dev_file)
	os.system ("cp /usr/src/redhat/SRPMS/%s ." % rpm_src_file)

	print "Generation of RPM files done."

# Edit the html files :-)
html_fix_version ("doc/index.html", conf_version)

if not os.path.isfile ("doc/index.html"):
	print "\n\n************* No doc/index.html ****************\n"
	sys.exit (1)

os.system ("cp -f %s doc/" % tar_gz_file)

if BUILD_ZIP:
	os.system ("cp -f %s doc/" % zip_file)

if BUILD_RPM:
	os.system ("cp -f %s doc/" % rpm_file)
	os.system ("cp -f %s doc/" % rpm_dev_file)
	os.system ("cp -f %s doc/" % rpm_src_file)
os.system ("cp -f ChangeLog doc/")
os.system ("cp -f NEWS doc/")

if len(sys.argv) == 2 and sys.argv [1] == "--copy":
	print "**************** Copying to Web Directory. ****************" ;

	os.system ("cp -f doc/* /home/erikd/HTML/Mega-Nerd/libsndfile/")
	os.system ("chmod a+r /home/erikd/HTML/Mega-Nerd/libsndfile/*")
	os.system ("rm -f /home/erikd/HTML/Mega-Nerd/libsndfile/Makefile*")
	sys.exit (0)
else:
	print "Not copying."



# Do not edit or modify anything in this comment block.
# The arch-tag line is a file identity tag for the GNU Arch 
# revision control system.
#
# arch-tag: 9ae5684a-b255-42d4-8fbd-74982b81c71b

