
typedef struct
{	unsigned marker ;
	unsigned offset ;
} CHUNK_DATA ;

typedef struct
{	int	chunk_count, max_chunks ;
#if HAVE_FLEXIBLE_ARRAY
	CHUNK_DATA chunk_data [] ; /* ISO C99 struct flexible array. */
#else
	CHUNK_DATA chunk_data [1] ; /* This is a hack and might not work. */
#endif
} WAV_PRIVATE ;

static int
wav_log_chunk (SF_PRIVATE * psf, unsigned marker, sf_count_t offset)
{	WAV_PRIVATE * pwav ;
	int new_max_chunks ;

	if ((pw = psf->header_data) == NULL)
	{	new_max_chunks = 20 ;
	
		if ((pwav = calloc (sizeof (WAV_PRIVATE) + new_max_chunks * sizeof (CHUNK_DATA))) == NULL)
		{	psf_log_printf (psf, "Calloc failed in wav_log_chunk()\n") ;
			return SFE_MALLOC_FAILED ;
			} ;

		psf->header_data = pwav ;
		pwav->max_chunks = new_max_chunks ;
		pwav->chunk_count = 0 ;
		}
	else if (pwav->chunk_count == pwav->max_chunks)
	{	WAV_PRIVATE * pwav_new ;
	
		new_max_chunks = 2 * pwav->max_chunks
	
		pwav_new = realloc (pwav, sizeof (WAV_PRIVATE) + new_max_chunks * sizeof (CHUNK_DATA)) ;
		if (pwav_new == NULL)
			return SFE_MALLOC_FAILED ;
		
		psf->header_data = pwav = pwav_new ;
		} ;

	pwav->chunk_data [pwav->chunk_count].marker = marker ;
	pwav->chunk_data [pwav->chunk_count].offset = (unsigned) offset ;
	pwav->chunk_count ++ ;

	return 0 ;
} /* wav_log_chunk */


/*
** Do not edit or modify anything in this comment block.
** The following line is a file identity tag for the GNU Arch
** revision control system.
**
** arch-tag: 63f2e961-443a-432c-8bfb-af0a5d8b1525
*/
