#!/usr/bin/python

import pprint, re, string, sys

class AutoMakeFile:
	def __init__ (self, filename):
		self.filename = filename

		# Get the directory.		
		file_path = string.split (filename, '/')
		self.dir = string.join (file_path [:-1], '/')

		self.vars = []
		self.dependancies = []
		self.rules = []
		
		file = open (filename, "r")
		lines = file.readlines ()
		file.close ()

		for k in range (len (lines)):
			print k			

# Private function used to clean each line of the Makefile.am
def _line_clean (line):
	line = string.rstrip (line) 
	line = re.sub ('#.*', '', line)
	line = re.sub ('\s+', ' ', line)
	line = re.sub ('^\s+', '\t', line)
	return line
	

def parse_makefile_dot_am (filename):
	variables = []
	dependancies = []
	makerules = []

	file_path = string.split (filename, '/')
	directory = string.join (file_path [:-1], '/')
	if not directory:
		directory = '.'
	
	file = open (filename, 'r')
	lines = file.readlines ()
	file.close ()
	
	lines = map (_line_clean, lines)

	line = ''
	line_count = len (lines)
	lines.append ('')
	k = -1
	while k < line_count - 1:
		k += 1

		# Zero length current_line so continue.
		if len (lines [k]) < 1:
			continue

		line += lines [k]

		if line [-1:] == '\\':
			line = line + '\n'
			continue

		if re.match ('[a-zA-Z0-9_]+\s*=', line):
			# print "variable   :", line
			var, value = re.split ('\s*=\s*', line, 2)
			variables.append ((var, value))
		elif re.match ('\s+', lines [k + 1]) and re.match ('[a-zA-Z0-9\.\s_-]+\s*:', line):
			dep = lines [k]
			rule = ''
			k += 1
			while re.match ('\s+', lines [k]):
				rule += lines [k] + '\n'
				k+= 1
			makerules.append ((dep, rule))

		elif re.match ('[a-zA-Z0-9\.\s_-]+\s*:', line):
			# print "dependancy :", line
			dependancies.append (line)
		else:
			err = "-------------------\nFile %s, bad line %d : \n%s\n-------------------\n" % (filename, k + 1, line)
			raise err
			
		line = ''

	am_data = {}
	am_data ['dir'] = directory
	am_data ['var'] = variables
	am_data ['dep'] = dependancies
	am_data ['rules'] = makerules
	return am_data

#===============================================================================

def recreate_am_file (am_data):
	variables = am_data ['var']
	for (var, value) in variables:
		print "%s = %s" % (var, value)
	
	dependancies = am_data ['dep']
	print
	for dep in dependancies:
		print dep, '\n'
	
	makerules = am_data ['rules']
	for (dep, rule) in makerules:
		print "%s\n%s" % (dep, rule)

#===============================================================================

if len (sys.argv) == 2:
	am_data = parse_makefile_dot_am (sys.argv [1])
else:
	am_data = parse_makefile_dot_am ('Makefile.am')
	
# generate_makefile_dot_in (am_data)

import pprint

pprint.pprint (am_data)

print "\n\n\n\n\n==================================================="

recreate_am_file (am_data)

# print data ['var'][2][1]


# Do not edit or modify anything in this comment block.
# The arch-tag line is a file identity tag for the GNU Arch 
# revision control system.
#
# arch-tag: f131403f-559e-4ab0-ae03-3b52b5193095

